<?php

declare(strict_types=1);

use yii;
use yii\bootstrap\ActiveForm;

// Инициализация
if (
    !yii::$app->user->isGuest
    && yii::$app->user->identity->agnt
) {
    $panel ?? $panel = 'profile_panel_settings_import';
} else {
    $panel ?? $panel = 'profile_panel_settings_account';
}

?>
<link href="/css/pages/profile.css" rel="stylesheet">

<div id="page_profile" class="container mb-auto">
    <div class="row h-100 py-3">
        <nav class="col-3">
            <?= $sidebar ?? yii::$app->controller->renderPartial('/profile/sidebar') ?>
        </nav>
        <article class="col-9">
            <div class="p-4 rounded">
                <h4 class="ml-4 mb-4"><i class="fas fa-sliders-h my-auto mr-2"></i>Настройки</h4>
                <div id="profile_panel_settings" class="profile_panel">
                    <div class="profile_panel_menu mb-3">
                        <label class="btn button_white mb-0 mr-2" for="profile_panel_settings_account">Аккаунт</label>
                        <?php
                        if (
                            !yii::$app->user->isGuest
                            && yii::$app->user->identity->agnt
                        ) {
                            echo <<<HTML
                                <label class="btn button_white mb-0 mr-2" for="profile_panel_settings_company">Компания</label>
                                <label class="btn button_white mb-0" for="profile_panel_settings_import">Импорт</label>
                            HTML;
                        }
                        ?>
                    </div>
                    <div class="profile_panel_content d-flex">
                        <input type="radio" id="profile_panel_settings_account" name="main_panel" <?= $panel === 'profile_panel_settings_account' ? 'checked' : null ?> />
                        <div class="col">
                            1
                        </div>

                        <?php if (
                            !yii::$app->user->isGuest
                            && yii::$app->user->identity->agnt
                        ) : ?>
                            <input type="radio" id="profile_panel_settings_company" name="main_panel" <?= $panel === 'profile_panel_settings_company' ? 'checked' : null ?> />
                            <div class="col">
                                2
                            </div>

                            <input type="radio" id="profile_panel_settings_import" name="main_panel" <?= $panel === 'profile_panel_settings_import' ? 'checked' : null ?> />
                            <div class="col">
                                <h5>Параметры 1C</h5>
                                <div class="dropdown-divider mb-3"></div>
                                <?php $form = ActiveForm::begin([
                                    'id' => 'form_profile_settings',
                                    'action' => false,
                                    'fieldConfig' => [
                                        'template' => '{label}{input}',
                                    ],
                                    'options' => [
                                        'onsubmit' => 'return false;'
                                    ]
                                ]);

                                // Инициализация
                                $model ?? $model = yii::$app->user->identity;
                                $list or $list = ['Нет данных'];
                                ?>

                                <?= $form->field($model, 'opts[import_sections_oem]', ['options' => ['class' => "mb-1"]])
                                    ->dropDownList($list, [
                                        'onChange' => 'page_profile_settings(this.parentElement.parentElement, \'profile_panel_settings_import\')',
                                        'disabled' => count($list) <= 1
                                    ])->label('OEM-номера'); ?>

                                <small class="d-block mb-1">Выберите поле в котором хранятся <b>ОЕМ-номера</b> и повторите импорт</small>
                                <small class="d-block">Значения взяты из импортированных товаров</small>

                                <?php ActiveForm::end(); ?>
                            </div>
                        <?php endif ?>
                    </div>
                </div>
            </div>
        </article>
    </div>
</div>

<script src="/js/profile.js" defer></script>
<?php if (
    !yii::$app->user->isGuest
    && yii::$app->user->identity->type === 'administrator'
    || yii::$app->user->identity->type === 'moderator'
) : ?>
    <script src="/js/profile_panel.js" defer></script>
<?php endif ?>